`timescale 1ns / 1ps

//******************************************************************************
//* Legnagyobb kzs oszt szmt modul.                                      *
//******************************************************************************
module lnko(
   input  wire       clk,           //rajel
   input  wire       rst,           //Reset jel
   input  wire       start,         //j szmts indtsa.
   input  wire [7:0] ai,            //'A' adatbemenet
   input  wire       lda,           //Az 'A' adat betlt jele
   input  wire [7:0] bi,            //'B' adatbemenet
   input  wire       ldb,           //A 'B' adat betlt jele
   output reg  [7:0] ao,            //Adatregiszterek
   output reg  [7:0] bo,
   output wire       ready,         //Szmts indthat jelzs
   output wire [2:0] fsm_state      //A vezrl aktulis llapota
);

//******************************************************************************
//* Az 'A' operandust s a rszeredmnyeket trol regiszter.                  *
//* A regiszter a port listban van deklarlva (ao).                           *
//******************************************************************************
wire [7:0] diff_ab;  //A kivon ltal szmtott klnbsg.
wire       ena;      //Betltst engedlyez jel.
wire       sela;     //Betltend adat kivlaszts: ai (0) / klnbsg (1).

//A kivon modul.
bin_sub_8bit sub_ab(.a(...), .b(...), .diff(diff_ab));


//******************************************************************************
//* A 'B' operandust s a rszeredmnyeket trol regiszter.                   *
//* A regiszter a port listban van deklarlva (bo).                           *
//******************************************************************************
wire [7:0] diff_ba;  //A kivon ltal szmtott klnbsg.
wire       enb;      //Betltst engedlyez jel.
wire       selb;     //Betltend adat kivlaszts: bi (0) / klnbsg (1).

//A kivon modul.
bin_sub_8bit sub_ba(.a(...), .b(...), .diff(diff_ba));


//******************************************************************************
//* Kompartor.                                                                *
//******************************************************************************
//Az 'A' regiszter rtke nagyobb, mint a 'B' regiszter rtke.
wire agtb = ...

//A 'B' regiszter rtke nagyobb, mint az 'A' regiszter rtke.
wire bgta = ...


//******************************************************************************
//* Vezrl llapotgp.                                                        *
//******************************************************************************
localparam IDLE  = 3'd0;
localparam LOADA = ...
localparam LOADB = ...
localparam TEST  = ...
localparam ASUBB = ...
localparam BSUBA = ...

//Letiltjuk az llapotkdols megvltoztatst, optimalizlst.
(* fsm_encoding = "user" *)
reg [2:0] state;

//Az llapotregiszter s a kvetkez llapot logika kzs always blokkban.


//Kimeneti logika.
assign ready = ...
assign ena   = ...
assign sela  = ...
assign enb   = ...
assign selb  = ...

//Kivezetjk az aktulis llapotot.
assign fsm_state = state;

endmodule
