`timescale 1ns / 1ps

//******************************************************************************
//* Legnagyobb kzs oszt szmt egysg top-level modulja.                   *
//******************************************************************************
module lnko_top(
   input  wire       clk16M,
   input  wire       clk,
   input  wire       rstbt,
   input  wire [2:0] bt,
   input  wire [7:0] sw,
   output wire [7:0] ld,
   output wire [7:0] seg_n,
   output wire [3:0] dig_n,
   output wire [4:0] col_n
);

//******************************************************************************
//* Legnagyobb kzs oszt szmt modul.                                      *
//******************************************************************************
wire [7:0] ao, bo;

lnko lnko_i(
   .clk(clk),           //rajel
   .rst(rstbt),         //Reset jel
   .start(bt[0]),       //j szmts indtsa
   .ai(sw),             //'A' adatbemenet
   .lda(bt[1]),         //Az 'A' adat betlt jele
   .bi(sw),             //'B' adatbemenet
   .ldb(bt[2]),         //A 'B' adat betlt jele
   .ao(ao),             //Adatregiszterek
   .bo(bo),
   .ready(ld[0]),       //Szmts indthat jelzs
   .fsm_state(ld[7:5])  //A vezrl aktulis llapota
);

//A nem hasznlt LED-eket kikapcsoljuk.
assign ld[4:1] = 4'b0000;


//******************************************************************************
//* 4 digites htszegmenses kijelz vezrl.                                   *
//******************************************************************************
wire [7:0] seg;
wire [3:0] dig;

LIP_4digit LIP_4digit_i(
   .clk16M(clk16M),           // 16MHz frekvencij rajel
   .rst(rstbt),               // Szinkron RESET jel
   .number({bo, ao}),         // 16 bites szm bemenet
   .dp(4'b0100),              // Tizedes pontok
   .seg(seg),                 // Szegmens kimenetek
   .dig(dig)                  // Digit kimenetek
);

//A kijelz vezrl jelek meghajtsa.
assign seg_n = ~seg;
assign dig_n = ~dig;
assign col_n = 5'b11111;

endmodule
